'use strict';

const Promise = require("bluebird");
const fs = Promise.promisifyAll(require("fs"));
const path = require("path");
const util = require("util");

const parse = require("./lib");

Promise.try(() => {
	return fs.readFileAsync(process.argv[2]);
}).then((contents) => {
	try {
		console.log(util.inspect(parse(contents.toString()), {colors: true, depth: null}));
	} catch (err) {
		console.error(util.inspect(err, {colors: true}));
	}
});
